import os, math

class clusterText:
    
    def __init__(self, directory,stopwordlist, k):
        self.k = k
        self.memberOf = {}
        self.stopwords = {}
        f = open(stopwordlist)
        for line in f:
            self.stopwords[line.strip()] = 1
        f.close()
        files = os.listdir(directory)
        #print(files)
        # document frequency is the number of documents the word occurred in
        self.tfIdf = {}
        self.documents = {}
        documentCount = 0
        total = 0
        documentFrequency = {}
        for file in files:
            print(file)
            documentCount += 1
            fileFreq = {}
            fileTotal = 0
            f = open(directory + '/' + file)
            lines = f.readlines()
            for line in lines:
                #print (line)
                tokens = line.split()
                for token in tokens:
                    token = token.strip('\'".,?:-')
                    token = token.lower()
                    if token != '' and not token in self.stopwords:
                        fileFreq.setdefault(token, 0)
                        fileTotal += 1
                        fileFreq[token] += 1
            for (token, count) in fileFreq.items():
                documentFrequency.setdefault(token, 0)
                documentFrequency[token] += 1
                         
            self.documents[file] = fileFreq                   
            f.close()
        self.N = len(documentFrequency)
        # now compute tf-idf
        for (doc, wordcounts) in self.documents.items():
            for (word,count) in wordcounts.items():
                #print(doc, word, count, documentFrequency[word])
                #compute tf-idf
                self.documents[doc][word] = (count * math.log(float(documentCount) / documentFrequency[word]))


        # hard code centroids for test
        self.centroids = [self.documents['moto1'], self.documents['poodle1']]
        self.assignPointsToCluster()

    def assignPointToCluster(self, v):
        minimum = 9999999
        clusterNum = -1
        for c in range(self.k):
            dist = pearson(v, self.centroids[c], self.N)
            if dist < minimum:
                minimum = dist
                clusterNum = c
        
        return clusterNum

    def assignPointsToCluster(self):
        """ assign each data point to a cluster"""
        for (doc, v) in self.documents.items():
            self.memberOf[doc] = self.assignPointToCluster(v)
                

def pearson(doc1, doc2, N):
    # get the sums
    v1 = doc1.values()
    v2 = doc2.values()
    sum1 = sum(doc1.values())
    sum2 = sum(doc2.values())
    #print ('sums', sum1, sum2)

    # sum of squares
    sumsq1 = sum([x**2 for x in doc1.values()])
    sumsq2 = sum([x**2 for x in doc2.values()])
    #print ('sumsq', sumsq1, sumsq2, N)

    #psum
    psum = 0
    for (word, tfidf) in doc1.items():
        if word in doc2:
            psum += tfidf + doc2[word]

    # finally calculate pearsons
    num = psum-(sum1*sum2/N) 
    #print((sumsq1 - sum1**2 / N) *  (sumsq2 - sum2**2 / N))
    denom = math.sqrt((sumsq1 - sum1**2 / N) *  (sumsq2 - sum2**2 / N))
    if denom == 0:
        return 1 # not sure if this is the best
    else:
        return 1 - num/denom
    

 
        
stopwordfile = "/Users/raz/Dropbox/guide/data/20news-bydate/stopwords0.txt"
#vt = vectorizeText('/Users/raz/Dropbox/research/cluster-analysis/data/smalltest/000174454000014')
vt = clusterText('tinytest2', stopwordfile, 2)
print(vt.memberOf)
